> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.nvidia.com/infra-controller/_mcp/server.

# Create Or Update BMC Credential

PUT https://nico-rest-api.nico.svc.cluster.local/v2/org/{org}/nico/credential/bmc
Content-Type: application/json

Create or update a site-wide or per-BMC root credential. Equivalent
to `carbide-admin-cli credential add-bmc`.

User must have authorization role with `PROVIDER_ADMIN` suffix.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/bmc-credential/create-or-update-bmc-credential

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NVIDIA Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/nico/credential/bmc:
    put:
      operationId: create-or-update-bmc-credential
      summary: Create Or Update BMC Credential
      description: |-
        Create or update a site-wide or per-BMC root credential. Equivalent
        to `carbide-admin-cli credential add-bmc`.

        User must have authorization role with `PROVIDER_ADMIN` suffix.
      tags:
        - subpackage_bmcCredential
      parameters:
        - name: org
          in: path
          description: Name of the Org
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/BMCCredential'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/NICoAPIError'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/BMCCredentialRequest'
servers:
  - url: https://nico-rest-api.nico.svc.cluster.local
    description: Kubernetes Cluster
components:
  schemas:
    BmcCredentialRequestKind:
      type: string
      enum:
        - site-wide-root
        - bmc-root
      description: Which BMC credential to store.
      title: BmcCredentialRequestKind
    BMCCredentialRequest:
      type: object
      properties:
        siteId:
          type: string
          format: uuid
          description: ID of the Site where the credential is stored.
        kind:
          $ref: '#/components/schemas/BmcCredentialRequestKind'
          description: Which BMC credential to store.
        password:
          type: string
          description: Credential password.
        username:
          type: string
          description: >-
            Optional username; Core defaults to "root" for bmc-root when
            omitted.
        macAddress:
          type: string
          description: >-
            BMC MAC address. Required for kind bmc-root, ignored for
            site-wide-root.
      required:
        - siteId
        - kind
        - password
      description: Request to create or update a BMC credential.
      title: BMCCredentialRequest
    BmcCredentialKind:
      type: string
      enum:
        - site-wide-root
        - bmc-root
      description: Which BMC credential was stored.
      title: BmcCredentialKind
    BMCCredential:
      type: object
      properties:
        siteId:
          type: string
          format: uuid
          description: ID of the Site where the credential is stored.
        kind:
          $ref: '#/components/schemas/BmcCredentialKind'
          description: Which BMC credential was stored.
        username:
          type: string
          description: >-
            Optional username; Core defaults to "root" for bmc-root when
            omitted.
        macAddress:
          type: string
          description: >-
            BMC MAC address. Required for kind bmc-root, ignored for
            site-wide-root.
      required:
        - siteId
        - kind
      description: >-
        BMC credential metadata returned after create or update. Password is
        never returned.
      title: BMCCredential
    NiCoApiErrorSource:
      type: string
      enum:
        - nico
      description: Source of the error.
      title: NiCoApiErrorSource
    NiCoApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: NiCoApiErrorData
    NICoAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/NiCoApiErrorSource'
          description: Source of the error.
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/NiCoApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NVIDIA Infra Controller REST API
      title: NICoAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://nico-rest-api.nico.svc.cluster.local/v2/org/$ORG_NAME/nico/user/current

        ```

```

## Examples



**Request**

```json
{
  "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
  "kind": "site-wide-root",
  "password": "S3cureP@ssw0rd!"
}
```

**Response**

```json
{
  "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
  "kind": "site-wide-root",
  "username": "admin",
  "macAddress": ""
}
```

**SDK Code**

```python
import requests

url = "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc"

payload = {
    "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
    "kind": "site-wide-root",
    "password": "S3cureP@ssw0rd!"
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"siteId":"3fa85f64-5717-4562-b3fc-2c963f66afa6","kind":"site-wide-root","password":"S3cureP@ssw0rd!"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc"

	payload := strings.NewReader("{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"kind\": \"site-wide-root\",\n  \"password\": \"S3cureP@ssw0rd!\"\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"kind\": \"site-wide-root\",\n  \"password\": \"S3cureP@ssw0rd!\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"kind\": \"site-wide-root\",\n  \"password\": \"S3cureP@ssw0rd!\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc', [
  'body' => '{
  "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
  "kind": "site-wide-root",
  "password": "S3cureP@ssw0rd!"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"siteId\": \"3fa85f64-5717-4562-b3fc-2c963f66afa6\",\n  \"kind\": \"site-wide-root\",\n  \"password\": \"S3cureP@ssw0rd!\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "siteId": "3fa85f64-5717-4562-b3fc-2c963f66afa6",
  "kind": "site-wide-root",
  "password": "S3cureP@ssw0rd!"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://nico-rest-api.nico.svc.cluster.local/v2/org/org/nico/credential/bmc")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```